cordova.define("com.sf.cordova.push.SFPush", function(require, exports, module) { function SFPush(){

}

// Call this to check device have registered for push notifications. 
SFPush.prototype.isOpened = function(successCallback) {
    if (successCallback && typeof successCallback != "function") {
        console.log("SFPush.isOpened failure: success callback parameter must be a function");
        return
    }

    cordova.exec(successCallback, null, "SFPush", "isOpened", []);
};

// Call this to register for push notifications. 
SFPush.prototype.registerDevice = function(badgeEnable, soundEnable, alertEnable, successCallback, errorCallback) {
    if (errorCallback == null) { errorCallback = function() {}}

    if (errorCallback && typeof errorCallback != "function")  {
        console.log("SFPush.registerDevice failure: error callback parameter must be a function");
        return
    }

    if (!successCallback) {
        console.log("SFPush.registerDevice failure: success callback parameter must be a function");
        return
    }

    cordova.exec(successCallback, errorCallback, "SFPush", "registerDevice", [badgeEnable, soundEnable, alertEnable]);
};

// Call this to unregister for push notifications
SFPush.prototype.unregisterDevice = function(successCallback) {
    if (successCallback && typeof successCallback != "function") {
        console.log("SFPush.unregisterDevice failure: success callback parameter must be a function");
        return
    }

     cordova.exec(successCallback, null, "SFPush", "unregisterDevice", []);
};

// Call this to set the application icon badge
SFPush.prototype.setApplicationIconBadgeNumber = function(badge, successCallback) {
    if (successCallback && typeof successCallback != "function") {
        console.log("SFPush.setApplicationIconBadgeNumber failure: success callback parameter must be a function");
        return
    }

    if (!badge) {
        console.log("SFPush.setApplicationIconBadgeNumber failure: badge parameter can not empty");
        return;
    };

    cordova.exec(successCallback, null, "SFPush", "setApplicationIconBadgeNumber", [badge]);
};

// Call this set how to receive notification
SFPush.prototype.setReceivedNotificationCallback = function(receiveCallback) {
    if (!receiveCallback) {
        console.log("SFPush.setReceivedNotificationCallback failure: receive callback parameter must be a function");
        return
    }

     cordova.exec(receiveCallback, null, "SFPush", "setReceivedNotificationCallback", []);
};

  module.exports = new SFPush();
});
